import java.util.*;

/**
 * Project #8.6
 * CS 2334, Section 001
 * October 12, 2003
 * <P>
 * This class models a list of states.  We will use this
 * as our data model for holding a list of states.
 * </P>
 * @author unknown, modified by DFH, March 6, 2008 to use generics (and clean up)
 * @version 1.1
 */
public class StateListModel 
{
   /** A list that holds the states. */
   private ArrayList<State> states;

   /**
    * Default constructor. This creates an empty list.
    */   
   public StateListModel() 
   {
      states = new ArrayList<State>();
   }
   
   /**
    * Returns the list as a vector.
    * <P>
    * @return   The list as a vector of states.
    */ 
   public Vector<State> getStatesVector() 
   {
      Vector<State> temp = new Vector<State>();

      ListIterator<State> statesIterator = states.listIterator();

      while( statesIterator.hasNext() )
      {
         temp.add(statesIterator.next());
      }

      return temp;
   }

   /**
    * Returns the list as an ArrayList.  This is the data model used
    * for the list.
    * <P>
    * @return   The list as an ArrayList of states.
    */ 
   public ArrayList<State> getStatesModel() 
   {
      return states;
   }
   
   /**
    * Removes a state from the list.
    * <P>
    * @param    index    The index of the state to remove.
    */   
   public void removeState(int index) 
   {
      if( index > -1 ) 
      {
         states.remove(index);
      }
   }

   /**
    * Returns a reference to the specified state.
    * <P>
    * @return    A reference to the state object stored 
    *            in position <code>index</code>.  Returns
    *            null if the index is < 0.
    */   
   public State getState(int index) 
   {  
      if( index > -1 )
      {
         return (State)states.get(index);
      }
      else
      {
         return null;
      }
   }
   
   /**
    * Adds a state to the list.
    * <P>
    * @param    State    Reference to the state to add to the list.
    */  
   public void addState(State newState) 
   {
      states.add(newState);
      sort();
   }

   /**
    * Sort the list.
    */
   private void sort() 
   {
      Collections.sort(states);    
   }  
}
